// Author: A.Voss@FH-Aachen.de
//
// static members
// tags: static

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class C {
    int n = 23;
    static int cnt; //  = 1; is not allowed
public:

    C()  { ++cnt; }
    ~C() { --cnt; }
    
    void set_n(int N) { n=N; }
    int get_n() const; // declaration only
    
    static int get_cnt() { return cnt; }
};

// define a class variable outside
int C::cnt = 0;

// a function defined outside 
int C::get_n() const { 
    return n; 
}

// access class members or functions via C::xxx,
// it is also possible via some object c1.xxx, however
int main()
{    
    C c1,c2; c2.set_n(42); 
    tools_log(); cout << "c1.n=" << c1.get_n() << ", c2.n=" << c2.get_n() 
                      << ", #Cs=" << C::get_cnt() << endl;

    if (true) {
        C c3;
        tools_log(); cout << "#Cs=" << C::get_cnt() << endl;
    }
    
    // call statics via objects - it is still a static (class) function
    tools_log(); cout << "#Cs=" << c1.get_cnt() << endl;
    
    return EXIT_SUCCESS;
}

